
/**
 * Copyright (C) 2006 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * debug section: 9 (sqlite cache)
 */

#include "squidwall.h"

#if WANT_SQLITE

void cache_init(void)
{
	stralloc sa;

	stralloc_init(&sa);

	debug(9,6, "cache_init() anfang");

	sql_init();
	if (!stralloc_copys(&sa, "CREATE TABLE IF NOT EXISTS tbl_cache (")) die_nomem();
	if (!stralloc_cats(&sa, " hash VARCHAR(32) NOT NULL UNIQUE,")) die_nomem();
	if (!stralloc_cats(&sa, " ts VARCHAR(25), url_host VARCHAR,")) die_nomem();
	if (!stralloc_cats(&sa, " url_path VARCHAR, mimetype VARCHAR,")) die_nomem();
	if (!stralloc_cats(&sa, " content BLOB)")) die_nomem();
	sql_exec(&sa);
	sql_quit();

	debug(9,6, "cache_init() ende");

	stralloc_free(&sa);

	return;
}
#endif
