
/**
 * Copyright (C) 2006 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * debug section: 13
 */

#include "squidwall.h"

/**
 * 
 */
int check_globals(request_t *r, int *todo)
{
	struct squidwall_acl *acl;

	r->bfilter_globals      = 0;
	r->bcfilter_globals     = 0;
	r->brfilter_globals     = 0;
	r->cfilter_globals      = 0;
	r->crfilter_globals     = 0;
	r->pfilter_globals      = 0;
	r->ufilter_globals      = 0;
	r->ufilter_md5_globals  = 0;
	r->ufilter_sha1_globals = 0;
	r->urfilter_globals     = 0;
	r->wfilter_globals      = 0;
	r->wrfilter_globals     = 0;

	if (globals) {
		acl = array_get(&array_globals, sizeof(struct squidwall_acl), 0);
		if (!acl) {
			panic("globals not defined");
			return ACL_NONE;
		}

		//debug_s(DEBUG_CHECK_GLOBALS, "@check_globals(): on");
		r->bfilter_globals      = &acl->bfilter;
		r->bcfilter_globals     = &acl->bcfilter;
		r->brfilter_globals     = &acl->brfilter;
		r->cfilter_globals      = &acl->cfilter;
		r->crfilter_globals     = &acl->crfilter;
		r->pfilter_globals      = &acl->pfilter;
		r->ufilter_globals      = &acl->ufilter;
		r->ufilter_md5_globals  = &acl->ufilter_md5;
		r->ufilter_sha1_globals = &acl->ufilter_sha1;
		r->urfilter_globals     = &acl->urfilter;
		r->wfilter_globals      = &acl->wfilter;
		r->wrfilter_globals     = &acl->wrfilter;
		set(*todo, acl->todo);
		return acl->flags;
	}

	return ACL_NONE;
}
