
/**
 * Copyright (C) 2005-2006 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * debug section: 13
 */

#include "squidwall.h"

/**
 * 
 */
int check_host(request_t *r, int *todo)
{
	struct squidwall_acl *acl;
	struct list_head *l;

	r->bfilter_host      = 0;
	r->bcfilter_host     = 0;
	r->brfilter_host     = 0;
	r->cfilter_host      = 0;
	r->crfilter_host     = 0;
	r->pfilter_host      = 0;
	r->ufilter_host      = 0;
	r->ufilter_md5_host  = 0;
	r->ufilter_sha1_host = 0;
	r->urfilter_host     = 0;
	r->wfilter_host      = 0;
	r->wrfilter_host     = 0;

	list_for_each(l, &hosts) {
		acl = list_entry(l, struct squidwall_acl, list);

		/* check ip */
		if (case_equals(acl->filename.s, r->ip.s)) {
			debug(13,3, "@check_host(%s)\n", r->ip.s);
			r->bfilter_host      = &acl->bfilter;
			r->bcfilter_host     = &acl->bcfilter;
			r->brfilter_host     = &acl->brfilter;
			r->cfilter_host      = &acl->cfilter;
			r->crfilter_host     = &acl->crfilter;
			r->pfilter_host      = &acl->pfilter;
			r->ufilter_host      = &acl->ufilter;
			r->ufilter_md5_host  = &acl->ufilter_md5;
			r->ufilter_sha1_host = &acl->ufilter_sha1;
			r->urfilter_host     = &acl->urfilter;
			r->wfilter_host      = &acl->wfilter;
			r->wrfilter_host     = &acl->wrfilter;
			set(*todo, acl->todo);
			return acl->flags;
		}

		/* check hostname */
		if (case_equals(acl->filename.s, r->host.s)) {
			debug(13,3, "@check_host(%s)\n", r->host.s);
			r->bfilter_host      = &acl->bfilter;
			r->bcfilter_host     = &acl->bcfilter;
			r->brfilter_host     = &acl->brfilter;
			r->cfilter_host      = &acl->cfilter;
			r->crfilter_host     = &acl->crfilter;
			r->pfilter_host      = &acl->pfilter;
			r->ufilter_host      = &acl->ufilter;
			r->ufilter_md5_host  = &acl->ufilter_md5;
			r->ufilter_sha1_host = &acl->ufilter_sha1;
			r->urfilter_host     = &acl->urfilter;
			r->wfilter_host      = &acl->wfilter;
			r->wrfilter_host     = &acl->wrfilter;
			set(*todo, acl->todo);
			return acl->flags;
		}
	}

	return ACL_NONE;
}
