
/**
 * Copyright (C) 2005-2006 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * debug section: 13
 */

#include "squidwall.h"

/**
 * redirecting via definitions from /etc/squidwall/redirects
 */
int check_user(request_t *r, int *todo)
{
	struct squidwall_acl *acl;
	struct list_head *l;

	r->bfilter_user      = 0;
	r->bcfilter_user     = 0;
	r->brfilter_user     = 0;
	r->cfilter_user      = 0;
	r->crfilter_user     = 0;
	r->pfilter_user      = 0;
	r->ufilter_user      = 0;
	r->ufilter_md5_user  = 0;
	r->ufilter_sha1_user = 0;
	r->urfilter_user     = 0;
	r->wfilter_user      = 0;
	r->wrfilter_user     = 0;

	list_for_each(l, &users) {
		acl = list_entry(l, struct squidwall_acl, list);

		/* check the username */
		if (case_equals(acl->filename.s, r->user.s)) {
			debug(13,3, "@check_user(%s) ", r->user.s);
			r->bfilter_user      = &acl->bfilter;
			r->bcfilter_user     = &acl->bcfilter;
			r->brfilter_user     = &acl->brfilter;
			r->cfilter_user      = &acl->cfilter;
			r->crfilter_user     = &acl->crfilter;
			r->pfilter_user      = &acl->pfilter;
			r->ufilter_user      = &acl->ufilter;
			r->ufilter_md5_user  = &acl->ufilter_md5;
			r->ufilter_sha1_user = &acl->ufilter_sha1;
			r->urfilter_user     = &acl->urfilter;
			r->wfilter_user      = &acl->wfilter;
			r->wrfilter_user     = &acl->wrfilter;
			set(*todo, acl->todo);
			return acl->flags;
		}
	}

	return ACL_NONE;
}
