#!/bin/sh

CONTROL="/etc/squidwall/control"
SERVER="http://192.168.100.6"
NETWORK="testing"

test -d $CONTROL || mkdir -p $CONTROL

echo 0     > $CONTROL/cache
echo 1     > $CONTROL/globals
echo 50000 > $CONTROL/maxsize
echo 50    > $CONTROL/memcache
echo 100   > $CONTROL/pfilter_max
echo 25    > $CONTROL/pfilter_default

echo "127.0.0.1:3128" > $CONTROL/proxy
echo "127.0.0.1:3310" > $CONTROL/clamav_tcp
echo "/var/lib/clamav/clamd.sock" > $CONTROL/clamav_socket

# 1+2+4+8
echo "15" > $CONTROL/logtodo
echo "/var/log/squid/squidwall.log" > $CONTROL/logfile

echo "$SERVER/inet/deny.php?network=$NETWORK&reason=user&" > $CONTROL/redir_baduser
echo "$SERVER/inet/deny.php?network=$NETWORK&reason=host&" > $CONTROL/redir_badhost
echo "$SERVER/inet/deny.php?network=$NETWORK&reason=cont&" > $CONTROL/redir_badcont
echo "$SERVER/inet/deny.php?network=$NETWORK&reason=url&" > $CONTROL/redir_badurl
echo "$SERVER/inet/deny.php?network=$NETWORK&reason=virus&" > $CONTROL/redir_virusfound
echo "$SERVER/inet/img/t.png" > $CONTROL/redir_bannerfound
echo "$SERVER"      > $CONTROL/redir_safesite
echo "$SERVER/inet" > $CONTROL/redir_webinterface

touch $CONTROL/!
