
/**
 * Copyright (C) 2006 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "fmtX.h"
#include "hextab.h"

unsigned long fmt_blob(char *dst, const char *src, unsigned long len)
{
	register const unsigned char *s=(const unsigned char*)src;
	unsigned long written=0,i;

	if (!dst) {
		/* x'12345' */
		return 2 + len*2 + 1;
	}

	*dst='x'; ++dst;
	*dst='\047'; ++dst;
	for (i=0; i<len; ++i) {
		*dst = hextab[s[i]/16]; ++dst;
		*dst = hextab[s[i]%16]; ++dst;
		written+=2;
	}
	*dst='\047'; ++dst; *dst=0;

	return 2 + written + 1;
}
