#ifndef SW_MEMCACHE_H
#define SW_MEMCACHE_H

/**
 * Copyright (C) 2006 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "params.h"
#include "request.h"

struct memcache {
	char hash[33];       /* md5(url, ip, host, user, method) */
	stralloc url;        /* rewritten url */
	time_t ts;           /* timestamp of: inserting or last hit */
};

extern void memcache_init(request_t *r);   /* initialize the cache */
extern void memcache_insert(request_t *r); /* inserts some new entry */
extern void memcache_reinit(request_t *r); /* reinit the cache */

/**
 * rewrites redirsite on MEMCACHE_HIT
 */
extern int memcache_lookup(request_t *r);
#define MEMCACHE_HIT  1
#define MEMCACHE_MISS 2

#endif /* SW_MEMCACHE_H */
